// Automatically generated by FFC, the FEniCS Form Compiler, version 0.2.2.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __ELASTICITY_H
#define __ELASTICITY_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/Vector.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Elasticity {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 12;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }
  
    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
      int offset = mesh.noNodes();
      values[1] = x(offset + vertex);
      offset = offset + mesh.noNodes();
      values[2] = x(offset + vertex);
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:
  
    TrialElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 12;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }
  
    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
      int offset = mesh.noNodes();
      values[1] = x(offset + vertex);
      offset = offset + mesh.noNodes();
      values[2] = x(offset + vertex);
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    const real G0_0_0 = map.det*map.g00*map.g00 + map.det*map.g00*map.g00 + map.det*map.g00*map.g00 + map.det*map.g00*map.g00 + map.det*map.g01*map.g01 + map.det*map.g02*map.g02 + map.det*map.g01*map.g01 + map.det*map.g02*map.g02;
    const real G0_0_1 = map.det*map.g00*map.g10 + map.det*map.g00*map.g10 + map.det*map.g00*map.g10 + map.det*map.g00*map.g10 + map.det*map.g01*map.g11 + map.det*map.g02*map.g12 + map.det*map.g01*map.g11 + map.det*map.g02*map.g12;
    const real G0_0_2 = map.det*map.g00*map.g20 + map.det*map.g00*map.g20 + map.det*map.g00*map.g20 + map.det*map.g00*map.g20 + map.det*map.g01*map.g21 + map.det*map.g02*map.g22 + map.det*map.g01*map.g21 + map.det*map.g02*map.g22;
    const real G0_1_0 = map.det*map.g10*map.g00 + map.det*map.g10*map.g00 + map.det*map.g10*map.g00 + map.det*map.g10*map.g00 + map.det*map.g11*map.g01 + map.det*map.g12*map.g02 + map.det*map.g11*map.g01 + map.det*map.g12*map.g02;
    const real G0_1_1 = map.det*map.g10*map.g10 + map.det*map.g10*map.g10 + map.det*map.g10*map.g10 + map.det*map.g10*map.g10 + map.det*map.g11*map.g11 + map.det*map.g12*map.g12 + map.det*map.g11*map.g11 + map.det*map.g12*map.g12;
    const real G0_1_2 = map.det*map.g10*map.g20 + map.det*map.g10*map.g20 + map.det*map.g10*map.g20 + map.det*map.g10*map.g20 + map.det*map.g11*map.g21 + map.det*map.g12*map.g22 + map.det*map.g11*map.g21 + map.det*map.g12*map.g22;
    const real G0_2_0 = map.det*map.g20*map.g00 + map.det*map.g20*map.g00 + map.det*map.g20*map.g00 + map.det*map.g20*map.g00 + map.det*map.g21*map.g01 + map.det*map.g22*map.g02 + map.det*map.g21*map.g01 + map.det*map.g22*map.g02;
    const real G0_2_1 = map.det*map.g20*map.g10 + map.det*map.g20*map.g10 + map.det*map.g20*map.g10 + map.det*map.g20*map.g10 + map.det*map.g21*map.g11 + map.det*map.g22*map.g12 + map.det*map.g21*map.g11 + map.det*map.g22*map.g12;
    const real G0_2_2 = map.det*map.g20*map.g20 + map.det*map.g20*map.g20 + map.det*map.g20*map.g20 + map.det*map.g20*map.g20 + map.det*map.g21*map.g21 + map.det*map.g22*map.g22 + map.det*map.g21*map.g21 + map.det*map.g22*map.g22;
    const real G1_0_0 = map.det*map.g01*map.g00 + map.det*map.g01*map.g00;
    const real G1_0_1 = map.det*map.g01*map.g10 + map.det*map.g01*map.g10;
    const real G1_0_2 = map.det*map.g01*map.g20 + map.det*map.g01*map.g20;
    const real G1_1_0 = map.det*map.g11*map.g00 + map.det*map.g11*map.g00;
    const real G1_1_1 = map.det*map.g11*map.g10 + map.det*map.g11*map.g10;
    const real G1_1_2 = map.det*map.g11*map.g20 + map.det*map.g11*map.g20;
    const real G1_2_0 = map.det*map.g21*map.g00 + map.det*map.g21*map.g00;
    const real G1_2_1 = map.det*map.g21*map.g10 + map.det*map.g21*map.g10;
    const real G1_2_2 = map.det*map.g21*map.g20 + map.det*map.g21*map.g20;
    const real G2_0_0 = map.det*map.g00*map.g01 + map.det*map.g00*map.g01;
    const real G2_0_1 = map.det*map.g00*map.g11 + map.det*map.g00*map.g11;
    const real G2_0_2 = map.det*map.g00*map.g21 + map.det*map.g00*map.g21;
    const real G2_1_0 = map.det*map.g10*map.g01 + map.det*map.g10*map.g01;
    const real G2_1_1 = map.det*map.g10*map.g11 + map.det*map.g10*map.g11;
    const real G2_1_2 = map.det*map.g10*map.g21 + map.det*map.g10*map.g21;
    const real G2_2_0 = map.det*map.g20*map.g01 + map.det*map.g20*map.g01;
    const real G2_2_1 = map.det*map.g20*map.g11 + map.det*map.g20*map.g11;
    const real G2_2_2 = map.det*map.g20*map.g21 + map.det*map.g20*map.g21;
    const real G3_0_0 = map.det*map.g00*map.g00 + map.det*map.g00*map.g00 + map.det*map.g01*map.g01 + map.det*map.g01*map.g01 + map.det*map.g01*map.g01 + map.det*map.g01*map.g01 + map.det*map.g02*map.g02 + map.det*map.g02*map.g02;
    const real G3_0_1 = map.det*map.g00*map.g10 + map.det*map.g00*map.g10 + map.det*map.g01*map.g11 + map.det*map.g01*map.g11 + map.det*map.g01*map.g11 + map.det*map.g01*map.g11 + map.det*map.g02*map.g12 + map.det*map.g02*map.g12;
    const real G3_0_2 = map.det*map.g00*map.g20 + map.det*map.g00*map.g20 + map.det*map.g01*map.g21 + map.det*map.g01*map.g21 + map.det*map.g01*map.g21 + map.det*map.g01*map.g21 + map.det*map.g02*map.g22 + map.det*map.g02*map.g22;
    const real G3_1_0 = map.det*map.g10*map.g00 + map.det*map.g10*map.g00 + map.det*map.g11*map.g01 + map.det*map.g11*map.g01 + map.det*map.g11*map.g01 + map.det*map.g11*map.g01 + map.det*map.g12*map.g02 + map.det*map.g12*map.g02;
    const real G3_1_1 = map.det*map.g10*map.g10 + map.det*map.g10*map.g10 + map.det*map.g11*map.g11 + map.det*map.g11*map.g11 + map.det*map.g11*map.g11 + map.det*map.g11*map.g11 + map.det*map.g12*map.g12 + map.det*map.g12*map.g12;
    const real G3_1_2 = map.det*map.g10*map.g20 + map.det*map.g10*map.g20 + map.det*map.g11*map.g21 + map.det*map.g11*map.g21 + map.det*map.g11*map.g21 + map.det*map.g11*map.g21 + map.det*map.g12*map.g22 + map.det*map.g12*map.g22;
    const real G3_2_0 = map.det*map.g20*map.g00 + map.det*map.g20*map.g00 + map.det*map.g21*map.g01 + map.det*map.g21*map.g01 + map.det*map.g21*map.g01 + map.det*map.g21*map.g01 + map.det*map.g22*map.g02 + map.det*map.g22*map.g02;
    const real G3_2_1 = map.det*map.g20*map.g10 + map.det*map.g20*map.g10 + map.det*map.g21*map.g11 + map.det*map.g21*map.g11 + map.det*map.g21*map.g11 + map.det*map.g21*map.g11 + map.det*map.g22*map.g12 + map.det*map.g22*map.g12;
    const real G3_2_2 = map.det*map.g20*map.g20 + map.det*map.g20*map.g20 + map.det*map.g21*map.g21 + map.det*map.g21*map.g21 + map.det*map.g21*map.g21 + map.det*map.g21*map.g21 + map.det*map.g22*map.g22 + map.det*map.g22*map.g22;
    const real G4_0_0 = map.det*map.g02*map.g00 + map.det*map.g02*map.g00;
    const real G4_0_1 = map.det*map.g02*map.g10 + map.det*map.g02*map.g10;
    const real G4_0_2 = map.det*map.g02*map.g20 + map.det*map.g02*map.g20;
    const real G4_1_0 = map.det*map.g12*map.g00 + map.det*map.g12*map.g00;
    const real G4_1_1 = map.det*map.g12*map.g10 + map.det*map.g12*map.g10;
    const real G4_1_2 = map.det*map.g12*map.g20 + map.det*map.g12*map.g20;
    const real G4_2_0 = map.det*map.g22*map.g00 + map.det*map.g22*map.g00;
    const real G4_2_1 = map.det*map.g22*map.g10 + map.det*map.g22*map.g10;
    const real G4_2_2 = map.det*map.g22*map.g20 + map.det*map.g22*map.g20;
    const real G5_0_0 = map.det*map.g00*map.g02 + map.det*map.g00*map.g02;
    const real G5_0_1 = map.det*map.g00*map.g12 + map.det*map.g00*map.g12;
    const real G5_0_2 = map.det*map.g00*map.g22 + map.det*map.g00*map.g22;
    const real G5_1_0 = map.det*map.g10*map.g02 + map.det*map.g10*map.g02;
    const real G5_1_1 = map.det*map.g10*map.g12 + map.det*map.g10*map.g12;
    const real G5_1_2 = map.det*map.g10*map.g22 + map.det*map.g10*map.g22;
    const real G5_2_0 = map.det*map.g20*map.g02 + map.det*map.g20*map.g02;
    const real G5_2_1 = map.det*map.g20*map.g12 + map.det*map.g20*map.g12;
    const real G5_2_2 = map.det*map.g20*map.g22 + map.det*map.g20*map.g22;
    const real G6_0_0 = map.det*map.g00*map.g00 + map.det*map.g01*map.g01 + map.det*map.g00*map.g00 + map.det*map.g01*map.g01 + map.det*map.g02*map.g02 + map.det*map.g02*map.g02 + map.det*map.g02*map.g02 + map.det*map.g02*map.g02;
    const real G6_0_1 = map.det*map.g00*map.g10 + map.det*map.g01*map.g11 + map.det*map.g00*map.g10 + map.det*map.g01*map.g11 + map.det*map.g02*map.g12 + map.det*map.g02*map.g12 + map.det*map.g02*map.g12 + map.det*map.g02*map.g12;
    const real G6_0_2 = map.det*map.g00*map.g20 + map.det*map.g01*map.g21 + map.det*map.g00*map.g20 + map.det*map.g01*map.g21 + map.det*map.g02*map.g22 + map.det*map.g02*map.g22 + map.det*map.g02*map.g22 + map.det*map.g02*map.g22;
    const real G6_1_0 = map.det*map.g10*map.g00 + map.det*map.g11*map.g01 + map.det*map.g10*map.g00 + map.det*map.g11*map.g01 + map.det*map.g12*map.g02 + map.det*map.g12*map.g02 + map.det*map.g12*map.g02 + map.det*map.g12*map.g02;
    const real G6_1_1 = map.det*map.g10*map.g10 + map.det*map.g11*map.g11 + map.det*map.g10*map.g10 + map.det*map.g11*map.g11 + map.det*map.g12*map.g12 + map.det*map.g12*map.g12 + map.det*map.g12*map.g12 + map.det*map.g12*map.g12;
    const real G6_1_2 = map.det*map.g10*map.g20 + map.det*map.g11*map.g21 + map.det*map.g10*map.g20 + map.det*map.g11*map.g21 + map.det*map.g12*map.g22 + map.det*map.g12*map.g22 + map.det*map.g12*map.g22 + map.det*map.g12*map.g22;
    const real G6_2_0 = map.det*map.g20*map.g00 + map.det*map.g21*map.g01 + map.det*map.g20*map.g00 + map.det*map.g21*map.g01 + map.det*map.g22*map.g02 + map.det*map.g22*map.g02 + map.det*map.g22*map.g02 + map.det*map.g22*map.g02;
    const real G6_2_1 = map.det*map.g20*map.g10 + map.det*map.g21*map.g11 + map.det*map.g20*map.g10 + map.det*map.g21*map.g11 + map.det*map.g22*map.g12 + map.det*map.g22*map.g12 + map.det*map.g22*map.g12 + map.det*map.g22*map.g12;
    const real G6_2_2 = map.det*map.g20*map.g20 + map.det*map.g21*map.g21 + map.det*map.g20*map.g20 + map.det*map.g21*map.g21 + map.det*map.g22*map.g22 + map.det*map.g22*map.g22 + map.det*map.g22*map.g22 + map.det*map.g22*map.g22;
    const real G7_0_0 = map.det*map.g02*map.g01 + map.det*map.g02*map.g01;
    const real G7_0_1 = map.det*map.g02*map.g11 + map.det*map.g02*map.g11;
    const real G7_0_2 = map.det*map.g02*map.g21 + map.det*map.g02*map.g21;
    const real G7_1_0 = map.det*map.g12*map.g01 + map.det*map.g12*map.g01;
    const real G7_1_1 = map.det*map.g12*map.g11 + map.det*map.g12*map.g11;
    const real G7_1_2 = map.det*map.g12*map.g21 + map.det*map.g12*map.g21;
    const real G7_2_0 = map.det*map.g22*map.g01 + map.det*map.g22*map.g01;
    const real G7_2_1 = map.det*map.g22*map.g11 + map.det*map.g22*map.g11;
    const real G7_2_2 = map.det*map.g22*map.g21 + map.det*map.g22*map.g21;
    const real G8_0_0 = map.det*map.g01*map.g02 + map.det*map.g01*map.g02;
    const real G8_0_1 = map.det*map.g01*map.g12 + map.det*map.g01*map.g12;
    const real G8_0_2 = map.det*map.g01*map.g22 + map.det*map.g01*map.g22;
    const real G8_1_0 = map.det*map.g11*map.g02 + map.det*map.g11*map.g02;
    const real G8_1_1 = map.det*map.g11*map.g12 + map.det*map.g11*map.g12;
    const real G8_1_2 = map.det*map.g11*map.g22 + map.det*map.g11*map.g22;
    const real G8_2_0 = map.det*map.g21*map.g02 + map.det*map.g21*map.g02;
    const real G8_2_1 = map.det*map.g21*map.g12 + map.det*map.g21*map.g12;
    const real G8_2_2 = map.det*map.g21*map.g22 + map.det*map.g21*map.g22;

    // Compute element tensor
    block[0] = 4.166666666666660e-02*G0_0_0 + 4.166666666666661e-02*G0_0_1 + 4.166666666666660e-02*G0_0_2 + 4.166666666666661e-02*G0_1_0 + 4.166666666666662e-02*G0_1_1 + 4.166666666666661e-02*G0_1_2 + 4.166666666666660e-02*G0_2_0 + 4.166666666666661e-02*G0_2_1 + 4.166666666666660e-02*G0_2_2;
    block[1] = -4.166666666666660e-02*G0_0_0 - 4.166666666666661e-02*G0_1_0 - 4.166666666666660e-02*G0_2_0;
    block[2] = -4.166666666666661e-02*G0_0_1 - 4.166666666666662e-02*G0_1_1 - 4.166666666666661e-02*G0_2_1;
    block[3] = -4.166666666666661e-02*G0_0_2 - 4.166666666666662e-02*G0_1_2 - 4.166666666666661e-02*G0_2_2;
    block[4] = 4.166666666666660e-02*G1_0_0 + 4.166666666666661e-02*G1_0_1 + 4.166666666666661e-02*G1_0_2 + 4.166666666666661e-02*G1_1_0 + 4.166666666666662e-02*G1_1_1 + 4.166666666666662e-02*G1_1_2 + 4.166666666666660e-02*G1_2_0 + 4.166666666666661e-02*G1_2_1 + 4.166666666666661e-02*G1_2_2;
    block[5] = -4.166666666666660e-02*G1_0_0 - 4.166666666666661e-02*G1_1_0 - 4.166666666666660e-02*G1_2_0;
    block[6] = -4.166666666666661e-02*G1_0_1 - 4.166666666666662e-02*G1_1_1 - 4.166666666666661e-02*G1_2_1;
    block[7] = -4.166666666666661e-02*G1_0_2 - 4.166666666666662e-02*G1_1_2 - 4.166666666666661e-02*G1_2_2;
    block[8] = 4.166666666666660e-02*G4_0_0 + 4.166666666666661e-02*G4_0_1 + 4.166666666666661e-02*G4_0_2 + 4.166666666666661e-02*G4_1_0 + 4.166666666666662e-02*G4_1_1 + 4.166666666666662e-02*G4_1_2 + 4.166666666666660e-02*G4_2_0 + 4.166666666666661e-02*G4_2_1 + 4.166666666666661e-02*G4_2_2;
    block[9] = -4.166666666666660e-02*G4_0_0 - 4.166666666666661e-02*G4_1_0 - 4.166666666666660e-02*G4_2_0;
    block[10] = -4.166666666666661e-02*G4_0_1 - 4.166666666666662e-02*G4_1_1 - 4.166666666666661e-02*G4_2_1;
    block[11] = -4.166666666666661e-02*G4_0_2 - 4.166666666666662e-02*G4_1_2 - 4.166666666666661e-02*G4_2_2;
    block[12] = -4.166666666666660e-02*G0_0_0 - 4.166666666666661e-02*G0_0_1 - 4.166666666666660e-02*G0_0_2;
    block[13] = 4.166666666666660e-02*G0_0_0;
    block[14] = 4.166666666666661e-02*G0_0_1;
    block[15] = 4.166666666666661e-02*G0_0_2;
    block[16] = -4.166666666666660e-02*G1_0_0 - 4.166666666666661e-02*G1_0_1 - 4.166666666666661e-02*G1_0_2;
    block[17] = 4.166666666666660e-02*G1_0_0;
    block[18] = 4.166666666666661e-02*G1_0_1;
    block[19] = 4.166666666666661e-02*G1_0_2;
    block[20] = -4.166666666666660e-02*G4_0_0 - 4.166666666666661e-02*G4_0_1 - 4.166666666666661e-02*G4_0_2;
    block[21] = 4.166666666666660e-02*G4_0_0;
    block[22] = 4.166666666666661e-02*G4_0_1;
    block[23] = 4.166666666666661e-02*G4_0_2;
    block[24] = -4.166666666666661e-02*G0_1_0 - 4.166666666666662e-02*G0_1_1 - 4.166666666666661e-02*G0_1_2;
    block[25] = 4.166666666666661e-02*G0_1_0;
    block[26] = 4.166666666666662e-02*G0_1_1;
    block[27] = 4.166666666666662e-02*G0_1_2;
    block[28] = -4.166666666666661e-02*G1_1_0 - 4.166666666666662e-02*G1_1_1 - 4.166666666666662e-02*G1_1_2;
    block[29] = 4.166666666666661e-02*G1_1_0;
    block[30] = 4.166666666666662e-02*G1_1_1;
    block[31] = 4.166666666666662e-02*G1_1_2;
    block[32] = -4.166666666666661e-02*G4_1_0 - 4.166666666666662e-02*G4_1_1 - 4.166666666666662e-02*G4_1_2;
    block[33] = 4.166666666666661e-02*G4_1_0;
    block[34] = 4.166666666666662e-02*G4_1_1;
    block[35] = 4.166666666666662e-02*G4_1_2;
    block[36] = -4.166666666666661e-02*G0_2_0 - 4.166666666666662e-02*G0_2_1 - 4.166666666666661e-02*G0_2_2;
    block[37] = 4.166666666666661e-02*G0_2_0;
    block[38] = 4.166666666666662e-02*G0_2_1;
    block[39] = 4.166666666666662e-02*G0_2_2;
    block[40] = -4.166666666666661e-02*G1_2_0 - 4.166666666666662e-02*G1_2_1 - 4.166666666666662e-02*G1_2_2;
    block[41] = 4.166666666666661e-02*G1_2_0;
    block[42] = 4.166666666666662e-02*G1_2_1;
    block[43] = 4.166666666666662e-02*G1_2_2;
    block[44] = -4.166666666666661e-02*G4_2_0 - 4.166666666666662e-02*G4_2_1 - 4.166666666666662e-02*G4_2_2;
    block[45] = 4.166666666666661e-02*G4_2_0;
    block[46] = 4.166666666666662e-02*G4_2_1;
    block[47] = 4.166666666666662e-02*G4_2_2;
    block[48] = 4.166666666666660e-02*G2_0_0 + 4.166666666666661e-02*G2_0_1 + 4.166666666666660e-02*G2_0_2 + 4.166666666666661e-02*G2_1_0 + 4.166666666666662e-02*G2_1_1 + 4.166666666666661e-02*G2_1_2 + 4.166666666666661e-02*G2_2_0 + 4.166666666666662e-02*G2_2_1 + 4.166666666666661e-02*G2_2_2;
    block[49] = -4.166666666666660e-02*G2_0_0 - 4.166666666666661e-02*G2_1_0 - 4.166666666666661e-02*G2_2_0;
    block[50] = -4.166666666666661e-02*G2_0_1 - 4.166666666666662e-02*G2_1_1 - 4.166666666666662e-02*G2_2_1;
    block[51] = -4.166666666666661e-02*G2_0_2 - 4.166666666666662e-02*G2_1_2 - 4.166666666666662e-02*G2_2_2;
    block[52] = 4.166666666666660e-02*G3_0_0 + 4.166666666666661e-02*G3_0_1 + 4.166666666666661e-02*G3_0_2 + 4.166666666666661e-02*G3_1_0 + 4.166666666666662e-02*G3_1_1 + 4.166666666666662e-02*G3_1_2 + 4.166666666666661e-02*G3_2_0 + 4.166666666666662e-02*G3_2_1 + 4.166666666666662e-02*G3_2_2;
    block[53] = -4.166666666666660e-02*G3_0_0 - 4.166666666666661e-02*G3_1_0 - 4.166666666666661e-02*G3_2_0;
    block[54] = -4.166666666666661e-02*G3_0_1 - 4.166666666666662e-02*G3_1_1 - 4.166666666666662e-02*G3_2_1;
    block[55] = -4.166666666666661e-02*G3_0_2 - 4.166666666666662e-02*G3_1_2 - 4.166666666666662e-02*G3_2_2;
    block[56] = 4.166666666666660e-02*G7_0_0 + 4.166666666666661e-02*G7_0_1 + 4.166666666666661e-02*G7_0_2 + 4.166666666666661e-02*G7_1_0 + 4.166666666666662e-02*G7_1_1 + 4.166666666666662e-02*G7_1_2 + 4.166666666666661e-02*G7_2_0 + 4.166666666666662e-02*G7_2_1 + 4.166666666666662e-02*G7_2_2;
    block[57] = -4.166666666666660e-02*G7_0_0 - 4.166666666666661e-02*G7_1_0 - 4.166666666666661e-02*G7_2_0;
    block[58] = -4.166666666666661e-02*G7_0_1 - 4.166666666666662e-02*G7_1_1 - 4.166666666666662e-02*G7_2_1;
    block[59] = -4.166666666666661e-02*G7_0_2 - 4.166666666666662e-02*G7_1_2 - 4.166666666666662e-02*G7_2_2;
    block[60] = -4.166666666666660e-02*G2_0_0 - 4.166666666666661e-02*G2_0_1 - 4.166666666666660e-02*G2_0_2;
    block[61] = 4.166666666666660e-02*G2_0_0;
    block[62] = 4.166666666666661e-02*G2_0_1;
    block[63] = 4.166666666666661e-02*G2_0_2;
    block[64] = -4.166666666666660e-02*G3_0_0 - 4.166666666666661e-02*G3_0_1 - 4.166666666666661e-02*G3_0_2;
    block[65] = 4.166666666666660e-02*G3_0_0;
    block[66] = 4.166666666666661e-02*G3_0_1;
    block[67] = 4.166666666666661e-02*G3_0_2;
    block[68] = -4.166666666666660e-02*G7_0_0 - 4.166666666666661e-02*G7_0_1 - 4.166666666666661e-02*G7_0_2;
    block[69] = 4.166666666666660e-02*G7_0_0;
    block[70] = 4.166666666666661e-02*G7_0_1;
    block[71] = 4.166666666666661e-02*G7_0_2;
    block[72] = -4.166666666666661e-02*G2_1_0 - 4.166666666666662e-02*G2_1_1 - 4.166666666666661e-02*G2_1_2;
    block[73] = 4.166666666666661e-02*G2_1_0;
    block[74] = 4.166666666666662e-02*G2_1_1;
    block[75] = 4.166666666666662e-02*G2_1_2;
    block[76] = -4.166666666666661e-02*G3_1_0 - 4.166666666666662e-02*G3_1_1 - 4.166666666666662e-02*G3_1_2;
    block[77] = 4.166666666666661e-02*G3_1_0;
    block[78] = 4.166666666666662e-02*G3_1_1;
    block[79] = 4.166666666666662e-02*G3_1_2;
    block[80] = -4.166666666666661e-02*G7_1_0 - 4.166666666666662e-02*G7_1_1 - 4.166666666666662e-02*G7_1_2;
    block[81] = 4.166666666666661e-02*G7_1_0;
    block[82] = 4.166666666666662e-02*G7_1_1;
    block[83] = 4.166666666666662e-02*G7_1_2;
    block[84] = -4.166666666666661e-02*G2_2_0 - 4.166666666666662e-02*G2_2_1 - 4.166666666666661e-02*G2_2_2;
    block[85] = 4.166666666666661e-02*G2_2_0;
    block[86] = 4.166666666666662e-02*G2_2_1;
    block[87] = 4.166666666666662e-02*G2_2_2;
    block[88] = -4.166666666666661e-02*G3_2_0 - 4.166666666666662e-02*G3_2_1 - 4.166666666666662e-02*G3_2_2;
    block[89] = 4.166666666666661e-02*G3_2_0;
    block[90] = 4.166666666666662e-02*G3_2_1;
    block[91] = 4.166666666666662e-02*G3_2_2;
    block[92] = -4.166666666666661e-02*G7_2_0 - 4.166666666666662e-02*G7_2_1 - 4.166666666666662e-02*G7_2_2;
    block[93] = 4.166666666666661e-02*G7_2_0;
    block[94] = 4.166666666666662e-02*G7_2_1;
    block[95] = 4.166666666666662e-02*G7_2_2;
    block[96] = 4.166666666666660e-02*G5_0_0 + 4.166666666666661e-02*G5_0_1 + 4.166666666666660e-02*G5_0_2 + 4.166666666666661e-02*G5_1_0 + 4.166666666666662e-02*G5_1_1 + 4.166666666666661e-02*G5_1_2 + 4.166666666666661e-02*G5_2_0 + 4.166666666666662e-02*G5_2_1 + 4.166666666666661e-02*G5_2_2;
    block[97] = -4.166666666666660e-02*G5_0_0 - 4.166666666666661e-02*G5_1_0 - 4.166666666666661e-02*G5_2_0;
    block[98] = -4.166666666666661e-02*G5_0_1 - 4.166666666666662e-02*G5_1_1 - 4.166666666666662e-02*G5_2_1;
    block[99] = -4.166666666666661e-02*G5_0_2 - 4.166666666666662e-02*G5_1_2 - 4.166666666666662e-02*G5_2_2;
    block[100] = 4.166666666666660e-02*G8_0_0 + 4.166666666666661e-02*G8_0_1 + 4.166666666666661e-02*G8_0_2 + 4.166666666666661e-02*G8_1_0 + 4.166666666666662e-02*G8_1_1 + 4.166666666666662e-02*G8_1_2 + 4.166666666666661e-02*G8_2_0 + 4.166666666666662e-02*G8_2_1 + 4.166666666666662e-02*G8_2_2;
    block[101] = -4.166666666666660e-02*G8_0_0 - 4.166666666666661e-02*G8_1_0 - 4.166666666666661e-02*G8_2_0;
    block[102] = -4.166666666666661e-02*G8_0_1 - 4.166666666666662e-02*G8_1_1 - 4.166666666666662e-02*G8_2_1;
    block[103] = -4.166666666666661e-02*G8_0_2 - 4.166666666666662e-02*G8_1_2 - 4.166666666666662e-02*G8_2_2;
    block[104] = 4.166666666666660e-02*G6_0_0 + 4.166666666666661e-02*G6_0_1 + 4.166666666666661e-02*G6_0_2 + 4.166666666666661e-02*G6_1_0 + 4.166666666666662e-02*G6_1_1 + 4.166666666666662e-02*G6_1_2 + 4.166666666666661e-02*G6_2_0 + 4.166666666666662e-02*G6_2_1 + 4.166666666666662e-02*G6_2_2;
    block[105] = -4.166666666666660e-02*G6_0_0 - 4.166666666666661e-02*G6_1_0 - 4.166666666666661e-02*G6_2_0;
    block[106] = -4.166666666666661e-02*G6_0_1 - 4.166666666666662e-02*G6_1_1 - 4.166666666666662e-02*G6_2_1;
    block[107] = -4.166666666666661e-02*G6_0_2 - 4.166666666666662e-02*G6_1_2 - 4.166666666666662e-02*G6_2_2;
    block[108] = -4.166666666666660e-02*G5_0_0 - 4.166666666666661e-02*G5_0_1 - 4.166666666666660e-02*G5_0_2;
    block[109] = 4.166666666666660e-02*G5_0_0;
    block[110] = 4.166666666666661e-02*G5_0_1;
    block[111] = 4.166666666666661e-02*G5_0_2;
    block[112] = -4.166666666666660e-02*G8_0_0 - 4.166666666666661e-02*G8_0_1 - 4.166666666666661e-02*G8_0_2;
    block[113] = 4.166666666666660e-02*G8_0_0;
    block[114] = 4.166666666666661e-02*G8_0_1;
    block[115] = 4.166666666666661e-02*G8_0_2;
    block[116] = -4.166666666666660e-02*G6_0_0 - 4.166666666666661e-02*G6_0_1 - 4.166666666666661e-02*G6_0_2;
    block[117] = 4.166666666666660e-02*G6_0_0;
    block[118] = 4.166666666666661e-02*G6_0_1;
    block[119] = 4.166666666666661e-02*G6_0_2;
    block[120] = -4.166666666666661e-02*G5_1_0 - 4.166666666666662e-02*G5_1_1 - 4.166666666666661e-02*G5_1_2;
    block[121] = 4.166666666666661e-02*G5_1_0;
    block[122] = 4.166666666666662e-02*G5_1_1;
    block[123] = 4.166666666666662e-02*G5_1_2;
    block[124] = -4.166666666666661e-02*G8_1_0 - 4.166666666666662e-02*G8_1_1 - 4.166666666666662e-02*G8_1_2;
    block[125] = 4.166666666666661e-02*G8_1_0;
    block[126] = 4.166666666666662e-02*G8_1_1;
    block[127] = 4.166666666666662e-02*G8_1_2;
    block[128] = -4.166666666666661e-02*G6_1_0 - 4.166666666666662e-02*G6_1_1 - 4.166666666666662e-02*G6_1_2;
    block[129] = 4.166666666666661e-02*G6_1_0;
    block[130] = 4.166666666666662e-02*G6_1_1;
    block[131] = 4.166666666666662e-02*G6_1_2;
    block[132] = -4.166666666666661e-02*G5_2_0 - 4.166666666666662e-02*G5_2_1 - 4.166666666666661e-02*G5_2_2;
    block[133] = 4.166666666666661e-02*G5_2_0;
    block[134] = 4.166666666666662e-02*G5_2_1;
    block[135] = 4.166666666666662e-02*G5_2_2;
    block[136] = -4.166666666666661e-02*G8_2_0 - 4.166666666666662e-02*G8_2_1 - 4.166666666666662e-02*G8_2_2;
    block[137] = 4.166666666666661e-02*G8_2_0;
    block[138] = 4.166666666666662e-02*G8_2_1;
    block[139] = 4.166666666666662e-02*G8_2_2;
    block[140] = -4.166666666666661e-02*G6_2_0 - 4.166666666666662e-02*G6_2_1 - 4.166666666666662e-02*G6_2_2;
    block[141] = 4.166666666666661e-02*G6_2_0;
    block[142] = 4.166666666666662e-02*G6_2_1;
    block[143] = 4.166666666666662e-02*G6_2_2;
  }

};

} }

#endif
