// Automatically generated by FFC, the FEniCS Form Compiler, version 0.2.2.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __ENERGYNORM_H
#define __ENERGYNORM_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/Vector.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace EnergyNorm {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class MultilinearForm : public dolfin::MultilinearForm
{
public:
  
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 4;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  MultilinearForm(Function& w0) : dolfin::MultilinearForm(1)
  {

    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute coefficients
    const real c0_0 = c[0][0];
    const real c0_1 = c[0][1];
    const real c0_2 = c[0][2];
    const real c0_3 = c[0][3];

    // Compute geometry tensors
    const real G0_0_0 = map.det*c0_0*c0_0;
    const real G0_0_1 = map.det*c0_0*c0_1;
    const real G0_0_2 = map.det*c0_0*c0_2;
    const real G0_0_3 = map.det*c0_0*c0_3;
    const real G0_1_0 = map.det*c0_1*c0_0;
    const real G0_1_1 = map.det*c0_1*c0_1;
    const real G0_1_2 = map.det*c0_1*c0_2;
    const real G0_1_3 = map.det*c0_1*c0_3;
    const real G0_2_0 = map.det*c0_2*c0_0;
    const real G0_2_1 = map.det*c0_2*c0_1;
    const real G0_2_2 = map.det*c0_2*c0_2;
    const real G0_2_3 = map.det*c0_2*c0_3;
    const real G0_3_0 = map.det*c0_3*c0_0;
    const real G0_3_1 = map.det*c0_3*c0_1;
    const real G0_3_2 = map.det*c0_3*c0_2;
    const real G0_3_3 = map.det*c0_3*c0_3;
    const real G1_0_0_0_0 = map.det*c0_0*c0_0*map.g00*map.g00 + map.det*c0_0*c0_0*map.g01*map.g01 + map.det*c0_0*c0_0*map.g02*map.g02;
    const real G1_0_0_0_1 = map.det*c0_0*c0_0*map.g00*map.g10 + map.det*c0_0*c0_0*map.g01*map.g11 + map.det*c0_0*c0_0*map.g02*map.g12;
    const real G1_0_0_0_2 = map.det*c0_0*c0_0*map.g00*map.g20 + map.det*c0_0*c0_0*map.g01*map.g21 + map.det*c0_0*c0_0*map.g02*map.g22;
    const real G1_0_0_1_0 = map.det*c0_0*c0_1*map.g00*map.g00 + map.det*c0_0*c0_1*map.g01*map.g01 + map.det*c0_0*c0_1*map.g02*map.g02;
    const real G1_0_0_2_1 = map.det*c0_0*c0_2*map.g00*map.g10 + map.det*c0_0*c0_2*map.g01*map.g11 + map.det*c0_0*c0_2*map.g02*map.g12;
    const real G1_0_0_3_2 = map.det*c0_0*c0_3*map.g00*map.g20 + map.det*c0_0*c0_3*map.g01*map.g21 + map.det*c0_0*c0_3*map.g02*map.g22;
    const real G1_0_1_0_0 = map.det*c0_0*c0_0*map.g10*map.g00 + map.det*c0_0*c0_0*map.g11*map.g01 + map.det*c0_0*c0_0*map.g12*map.g02;
    const real G1_0_1_0_1 = map.det*c0_0*c0_0*map.g10*map.g10 + map.det*c0_0*c0_0*map.g11*map.g11 + map.det*c0_0*c0_0*map.g12*map.g12;
    const real G1_0_1_0_2 = map.det*c0_0*c0_0*map.g10*map.g20 + map.det*c0_0*c0_0*map.g11*map.g21 + map.det*c0_0*c0_0*map.g12*map.g22;
    const real G1_0_1_1_0 = map.det*c0_0*c0_1*map.g10*map.g00 + map.det*c0_0*c0_1*map.g11*map.g01 + map.det*c0_0*c0_1*map.g12*map.g02;
    const real G1_0_1_2_1 = map.det*c0_0*c0_2*map.g10*map.g10 + map.det*c0_0*c0_2*map.g11*map.g11 + map.det*c0_0*c0_2*map.g12*map.g12;
    const real G1_0_1_3_2 = map.det*c0_0*c0_3*map.g10*map.g20 + map.det*c0_0*c0_3*map.g11*map.g21 + map.det*c0_0*c0_3*map.g12*map.g22;
    const real G1_0_2_0_0 = map.det*c0_0*c0_0*map.g20*map.g00 + map.det*c0_0*c0_0*map.g21*map.g01 + map.det*c0_0*c0_0*map.g22*map.g02;
    const real G1_0_2_0_1 = map.det*c0_0*c0_0*map.g20*map.g10 + map.det*c0_0*c0_0*map.g21*map.g11 + map.det*c0_0*c0_0*map.g22*map.g12;
    const real G1_0_2_0_2 = map.det*c0_0*c0_0*map.g20*map.g20 + map.det*c0_0*c0_0*map.g21*map.g21 + map.det*c0_0*c0_0*map.g22*map.g22;
    const real G1_0_2_1_0 = map.det*c0_0*c0_1*map.g20*map.g00 + map.det*c0_0*c0_1*map.g21*map.g01 + map.det*c0_0*c0_1*map.g22*map.g02;
    const real G1_0_2_2_1 = map.det*c0_0*c0_2*map.g20*map.g10 + map.det*c0_0*c0_2*map.g21*map.g11 + map.det*c0_0*c0_2*map.g22*map.g12;
    const real G1_0_2_3_2 = map.det*c0_0*c0_3*map.g20*map.g20 + map.det*c0_0*c0_3*map.g21*map.g21 + map.det*c0_0*c0_3*map.g22*map.g22;
    const real G1_1_0_0_0 = map.det*c0_1*c0_0*map.g00*map.g00 + map.det*c0_1*c0_0*map.g01*map.g01 + map.det*c0_1*c0_0*map.g02*map.g02;
    const real G1_1_0_0_1 = map.det*c0_1*c0_0*map.g00*map.g10 + map.det*c0_1*c0_0*map.g01*map.g11 + map.det*c0_1*c0_0*map.g02*map.g12;
    const real G1_1_0_0_2 = map.det*c0_1*c0_0*map.g00*map.g20 + map.det*c0_1*c0_0*map.g01*map.g21 + map.det*c0_1*c0_0*map.g02*map.g22;
    const real G1_1_0_1_0 = map.det*c0_1*c0_1*map.g00*map.g00 + map.det*c0_1*c0_1*map.g01*map.g01 + map.det*c0_1*c0_1*map.g02*map.g02;
    const real G1_1_0_2_1 = map.det*c0_1*c0_2*map.g00*map.g10 + map.det*c0_1*c0_2*map.g01*map.g11 + map.det*c0_1*c0_2*map.g02*map.g12;
    const real G1_1_0_3_2 = map.det*c0_1*c0_3*map.g00*map.g20 + map.det*c0_1*c0_3*map.g01*map.g21 + map.det*c0_1*c0_3*map.g02*map.g22;
    const real G1_2_1_0_0 = map.det*c0_2*c0_0*map.g10*map.g00 + map.det*c0_2*c0_0*map.g11*map.g01 + map.det*c0_2*c0_0*map.g12*map.g02;
    const real G1_2_1_0_1 = map.det*c0_2*c0_0*map.g10*map.g10 + map.det*c0_2*c0_0*map.g11*map.g11 + map.det*c0_2*c0_0*map.g12*map.g12;
    const real G1_2_1_0_2 = map.det*c0_2*c0_0*map.g10*map.g20 + map.det*c0_2*c0_0*map.g11*map.g21 + map.det*c0_2*c0_0*map.g12*map.g22;
    const real G1_2_1_1_0 = map.det*c0_2*c0_1*map.g10*map.g00 + map.det*c0_2*c0_1*map.g11*map.g01 + map.det*c0_2*c0_1*map.g12*map.g02;
    const real G1_2_1_2_1 = map.det*c0_2*c0_2*map.g10*map.g10 + map.det*c0_2*c0_2*map.g11*map.g11 + map.det*c0_2*c0_2*map.g12*map.g12;
    const real G1_2_1_3_2 = map.det*c0_2*c0_3*map.g10*map.g20 + map.det*c0_2*c0_3*map.g11*map.g21 + map.det*c0_2*c0_3*map.g12*map.g22;
    const real G1_3_2_0_0 = map.det*c0_3*c0_0*map.g20*map.g00 + map.det*c0_3*c0_0*map.g21*map.g01 + map.det*c0_3*c0_0*map.g22*map.g02;
    const real G1_3_2_0_1 = map.det*c0_3*c0_0*map.g20*map.g10 + map.det*c0_3*c0_0*map.g21*map.g11 + map.det*c0_3*c0_0*map.g22*map.g12;
    const real G1_3_2_0_2 = map.det*c0_3*c0_0*map.g20*map.g20 + map.det*c0_3*c0_0*map.g21*map.g21 + map.det*c0_3*c0_0*map.g22*map.g22;
    const real G1_3_2_1_0 = map.det*c0_3*c0_1*map.g20*map.g00 + map.det*c0_3*c0_1*map.g21*map.g01 + map.det*c0_3*c0_1*map.g22*map.g02;
    const real G1_3_2_2_1 = map.det*c0_3*c0_2*map.g20*map.g10 + map.det*c0_3*c0_2*map.g21*map.g11 + map.det*c0_3*c0_2*map.g22*map.g12;
    const real G1_3_2_3_2 = map.det*c0_3*c0_3*map.g20*map.g20 + map.det*c0_3*c0_3*map.g21*map.g21 + map.det*c0_3*c0_3*map.g22*map.g22;

    // Compute element tensor
    block[0] = 1.666666666666662e-02*G0_0_0 + 8.333333333333309e-03*G0_0_1 + 8.333333333333307e-03*G0_0_2 + 8.333333333333312e-03*G0_0_3 + 8.333333333333309e-03*G0_1_0 + 1.666666666666662e-02*G0_1_1 + 8.333333333333311e-03*G0_1_2 + 8.333333333333312e-03*G0_1_3 + 8.333333333333307e-03*G0_2_0 + 8.333333333333311e-03*G0_2_1 + 1.666666666666662e-02*G0_2_2 + 8.333333333333312e-03*G0_2_3 + 8.333333333333312e-03*G0_3_0 + 8.333333333333312e-03*G0_3_1 + 8.333333333333311e-03*G0_3_2 + 1.666666666666662e-02*G0_3_3 + 1.666666666666664e-01*G1_0_0_0_0 + 1.666666666666664e-01*G1_0_0_0_1 + 1.666666666666664e-01*G1_0_0_0_2 - 1.666666666666664e-01*G1_0_0_1_0 - 1.666666666666664e-01*G1_0_0_2_1 - 1.666666666666664e-01*G1_0_0_3_2 + 1.666666666666664e-01*G1_0_1_0_0 + 1.666666666666665e-01*G1_0_1_0_1 + 1.666666666666665e-01*G1_0_1_0_2 - 1.666666666666664e-01*G1_0_1_1_0 - 1.666666666666665e-01*G1_0_1_2_1 - 1.666666666666665e-01*G1_0_1_3_2 + 1.666666666666664e-01*G1_0_2_0_0 + 1.666666666666665e-01*G1_0_2_0_1 + 1.666666666666665e-01*G1_0_2_0_2 - 1.666666666666664e-01*G1_0_2_1_0 - 1.666666666666665e-01*G1_0_2_2_1 - 1.666666666666665e-01*G1_0_2_3_2 - 1.666666666666664e-01*G1_1_0_0_0 - 1.666666666666664e-01*G1_1_0_0_1 - 1.666666666666664e-01*G1_1_0_0_2 + 1.666666666666664e-01*G1_1_0_1_0 + 1.666666666666664e-01*G1_1_0_2_1 + 1.666666666666664e-01*G1_1_0_3_2 - 1.666666666666664e-01*G1_2_1_0_0 - 1.666666666666665e-01*G1_2_1_0_1 - 1.666666666666665e-01*G1_2_1_0_2 + 1.666666666666664e-01*G1_2_1_1_0 + 1.666666666666665e-01*G1_2_1_2_1 + 1.666666666666665e-01*G1_2_1_3_2 - 1.666666666666664e-01*G1_3_2_0_0 - 1.666666666666665e-01*G1_3_2_0_1 - 1.666666666666665e-01*G1_3_2_0_2 + 1.666666666666664e-01*G1_3_2_1_0 + 1.666666666666665e-01*G1_3_2_2_1 + 1.666666666666665e-01*G1_3_2_3_2;
  }

};

} }

#endif
