// Automatically generated by FFC, the FEniCS Form Compiler, version 0.2.2.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __MASS_H
#define __MASS_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/Vector.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Mass {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 20;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][2] = {{0, 1}, {1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[4] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(1);
      dofs[6] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[7] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(2);
      dofs[8] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[9] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(3);
      dofs[10] = offset + 2*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[11] = offset + 2*cell.edgeID(3) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(4);
      dofs[12] = offset + 2*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[13] = offset + 2*cell.edgeID(4) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(5);
      dofs[14] = offset + 2*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[15] = offset + 2*cell.edgeID(5) + edge_reordering_0[alignment][1];
      offset = offset + 2*mesh.noEdges();
      dofs[16] = offset + cell.faceID(0);
      dofs[17] = offset + cell.faceID(1);
      dofs[18] = offset + cell.faceID(2);
      dofs[19] = offset + cell.faceID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(6.666666666666667e-01, 3.333333333333333e-01, 0.000000000000000e+00);
      points[5] = map(3.333333333333334e-01, 6.666666666666666e-01, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 6.666666666666667e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 3.333333333333334e-01, 0.000000000000000e+00);
      points[8] = map(3.333333333333333e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(6.666666666666666e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 3.333333333333333e-01);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 6.666666666666666e-01);
      points[12] = map(6.666666666666667e-01, 0.000000000000000e+00, 3.333333333333333e-01);
      points[13] = map(3.333333333333334e-01, 0.000000000000000e+00, 6.666666666666666e-01);
      points[14] = map(0.000000000000000e+00, 6.666666666666667e-01, 3.333333333333333e-01);
      points[15] = map(0.000000000000000e+00, 3.333333333333334e-01, 6.666666666666666e-01);
      points[16] = map(3.333333333333334e-01, 3.333333333333333e-01, 3.333333333333333e-01);
      points[17] = map(0.000000000000000e+00, 3.333333333333334e-01, 3.333333333333333e-01);
      points[18] = map(3.333333333333333e-01, 0.000000000000000e+00, 3.333333333333334e-01);
      points[19] = map(3.333333333333333e-01, 3.333333333333333e-01, 0.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:
  
    TrialElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 20;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][2] = {{0, 1}, {1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[4] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(1);
      dofs[6] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[7] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(2);
      dofs[8] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[9] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(3);
      dofs[10] = offset + 2*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[11] = offset + 2*cell.edgeID(3) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(4);
      dofs[12] = offset + 2*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[13] = offset + 2*cell.edgeID(4) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(5);
      dofs[14] = offset + 2*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[15] = offset + 2*cell.edgeID(5) + edge_reordering_0[alignment][1];
      offset = offset + 2*mesh.noEdges();
      dofs[16] = offset + cell.faceID(0);
      dofs[17] = offset + cell.faceID(1);
      dofs[18] = offset + cell.faceID(2);
      dofs[19] = offset + cell.faceID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(6.666666666666667e-01, 3.333333333333333e-01, 0.000000000000000e+00);
      points[5] = map(3.333333333333334e-01, 6.666666666666666e-01, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 6.666666666666667e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 3.333333333333334e-01, 0.000000000000000e+00);
      points[8] = map(3.333333333333333e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(6.666666666666666e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 3.333333333333333e-01);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 6.666666666666666e-01);
      points[12] = map(6.666666666666667e-01, 0.000000000000000e+00, 3.333333333333333e-01);
      points[13] = map(3.333333333333334e-01, 0.000000000000000e+00, 6.666666666666666e-01);
      points[14] = map(0.000000000000000e+00, 6.666666666666667e-01, 3.333333333333333e-01);
      points[15] = map(0.000000000000000e+00, 3.333333333333334e-01, 6.666666666666666e-01);
      points[16] = map(3.333333333333334e-01, 3.333333333333333e-01, 3.333333333333333e-01);
      points[17] = map(0.000000000000000e+00, 3.333333333333334e-01, 3.333333333333333e-01);
      points[18] = map(3.333333333333333e-01, 0.000000000000000e+00, 3.333333333333334e-01);
      points[19] = map(3.333333333333333e-01, 3.333333333333333e-01, 0.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    const real G0_ = map.det;

    // Compute element tensor
    block[0] = 5.952380952380944e-04*G0_;
    block[1] = 7.440476190476180e-05*G0_;
    block[2] = 7.440476190476188e-05*G0_;
    block[3] = 7.440476190476180e-05*G0_;
    block[4] = 1.116071428571429e-04*G0_;
    block[5] = 1.116071428571420e-04*G0_;
    block[6] = 2.232142857142851e-04*G0_;
    block[7] = -4.464285714285707e-04*G0_;
    block[8] = -4.464285714285714e-04*G0_;
    block[9] = 2.232142857142858e-04*G0_;
    block[10] = -4.464285714285711e-04*G0_;
    block[11] = 2.232142857142859e-04*G0_;
    block[12] = 1.116071428571427e-04*G0_;
    block[13] = 1.116071428571431e-04*G0_;
    block[14] = 1.116071428571427e-04*G0_;
    block[15] = 1.116071428571432e-04*G0_;
    block[16] = 1.339285714285713e-03*G0_;
    block[17] = 6.696428571428562e-04*G0_;
    block[18] = 6.696428571428571e-04*G0_;
    block[19] = 6.696428571428561e-04*G0_;
    block[20] = 7.440476190476180e-05*G0_;
    block[21] = 5.952380952380941e-04*G0_;
    block[22] = 7.440476190476188e-05*G0_;
    block[23] = 7.440476190476175e-05*G0_;
    block[24] = -4.464285714285719e-04*G0_;
    block[25] = 2.232142857142856e-04*G0_;
    block[26] = 1.116071428571422e-04*G0_;
    block[27] = 1.116071428571426e-04*G0_;
    block[28] = 2.232142857142856e-04*G0_;
    block[29] = -4.464285714285715e-04*G0_;
    block[30] = 1.116071428571425e-04*G0_;
    block[31] = 1.116071428571428e-04*G0_;
    block[32] = -4.464285714285719e-04*G0_;
    block[33] = 2.232142857142860e-04*G0_;
    block[34] = 1.116071428571433e-04*G0_;
    block[35] = 1.116071428571429e-04*G0_;
    block[36] = 6.696428571428579e-04*G0_;
    block[37] = 1.339285714285713e-03*G0_;
    block[38] = 6.696428571428576e-04*G0_;
    block[39] = 6.696428571428564e-04*G0_;
    block[40] = 7.440476190476188e-05*G0_;
    block[41] = 7.440476190476190e-05*G0_;
    block[42] = 5.952380952380949e-04*G0_;
    block[43] = 7.440476190476184e-05*G0_;
    block[44] = 2.232142857142848e-04*G0_;
    block[45] = -4.464285714285706e-04*G0_;
    block[46] = -4.464285714285713e-04*G0_;
    block[47] = 2.232142857142855e-04*G0_;
    block[48] = 1.116071428571422e-04*G0_;
    block[49] = 1.116071428571425e-04*G0_;
    block[50] = 1.116071428571426e-04*G0_;
    block[51] = 1.116071428571427e-04*G0_;
    block[52] = 1.116071428571421e-04*G0_;
    block[53] = 1.116071428571431e-04*G0_;
    block[54] = -4.464285714285708e-04*G0_;
    block[55] = 2.232142857142857e-04*G0_;
    block[56] = 6.696428571428568e-04*G0_;
    block[57] = 6.696428571428570e-04*G0_;
    block[58] = 1.339285714285713e-03*G0_;
    block[59] = 6.696428571428575e-04*G0_;
    block[60] = 7.440476190476180e-05*G0_;
    block[61] = 7.440476190476175e-05*G0_;
    block[62] = 7.440476190476186e-05*G0_;
    block[63] = 5.952380952380946e-04*G0_;
    block[64] = 1.116071428571424e-04*G0_;
    block[65] = 1.116071428571427e-04*G0_;
    block[66] = 1.116071428571424e-04*G0_;
    block[67] = 1.116071428571425e-04*G0_;
    block[68] = 1.116071428571424e-04*G0_;
    block[69] = 1.116071428571429e-04*G0_;
    block[70] = 2.232142857142850e-04*G0_;
    block[71] = -4.464285714285702e-04*G0_;
    block[72] = 2.232142857142850e-04*G0_;
    block[73] = -4.464285714285703e-04*G0_;
    block[74] = 2.232142857142855e-04*G0_;
    block[75] = -4.464285714285702e-04*G0_;
    block[76] = 6.696428571428557e-04*G0_;
    block[77] = 6.696428571428558e-04*G0_;
    block[78] = 6.696428571428566e-04*G0_;
    block[79] = 1.339285714285711e-03*G0_;
    block[80] = 1.116071428571429e-04*G0_;
    block[81] = -4.464285714285720e-04*G0_;
    block[82] = 2.232142857142848e-04*G0_;
    block[83] = 1.116071428571424e-04*G0_;
    block[84] = 4.017857142857131e-03*G0_;
    block[85] = -2.008928571428567e-03*G0_;
    block[86] = -1.004464285714283e-03*G0_;
    block[87] = 0.000000000000000e+00;
    block[88] = -1.004464285714285e-03*G0_;
    block[89] = 2.008928571428569e-03*G0_;
    block[90] = 0.000000000000000e+00;
    block[91] = 0.000000000000000e+00;
    block[92] = 2.008928571428565e-03*G0_;
    block[93] = -1.004464285714282e-03*G0_;
    block[94] = -1.004464285714285e-03*G0_;
    block[95] = 0.000000000000000e+00;
    block[96] = 0.000000000000000e+00;
    block[97] = -2.008928571428568e-03*G0_;
    block[98] = 0.000000000000000e+00;
    block[99] = 0.000000000000000e+00;
    block[100] = 1.116071428571421e-04*G0_;
    block[101] = 2.232142857142856e-04*G0_;
    block[102] = -4.464285714285706e-04*G0_;
    block[103] = 1.116071428571427e-04*G0_;
    block[104] = -2.008928571428567e-03*G0_;
    block[105] = 4.017857142857137e-03*G0_;
    block[106] = 2.008928571428569e-03*G0_;
    block[107] = -1.004464285714284e-03*G0_;
    block[108] = 0.000000000000000e+00;
    block[109] = -1.004464285714284e-03*G0_;
    block[110] = 0.000000000000000e+00;
    block[111] = 0.000000000000000e+00;
    block[112] = -1.004464285714282e-03*G0_;
    block[113] = 0.000000000000000e+00;
    block[114] = 2.008928571428570e-03*G0_;
    block[115] = -1.004464285714285e-03*G0_;
    block[116] = 0.000000000000000e+00;
    block[117] = 0.000000000000000e+00;
    block[118] = -2.008928571428570e-03*G0_;
    block[119] = 0.000000000000000e+00;
    block[120] = 2.232142857142851e-04*G0_;
    block[121] = 1.116071428571422e-04*G0_;
    block[122] = -4.464285714285713e-04*G0_;
    block[123] = 1.116071428571424e-04*G0_;
    block[124] = -1.004464285714283e-03*G0_;
    block[125] = 2.008928571428569e-03*G0_;
    block[126] = 4.017857142857134e-03*G0_;
    block[127] = -2.008928571428569e-03*G0_;
    block[128] = -1.004464285714284e-03*G0_;
    block[129] = 0.000000000000000e+00;
    block[130] = -1.004464285714284e-03*G0_;
    block[131] = 0.000000000000000e+00;
    block[132] = 0.000000000000000e+00;
    block[133] = 0.000000000000000e+00;
    block[134] = 2.008928571428568e-03*G0_;
    block[135] = -1.004464285714284e-03*G0_;
    block[136] = 0.000000000000000e+00;
    block[137] = 0.000000000000000e+00;
    block[138] = -2.008928571428570e-03*G0_;
    block[139] = 0.000000000000000e+00;
    block[140] = -4.464285714285707e-04*G0_;
    block[141] = 1.116071428571426e-04*G0_;
    block[142] = 2.232142857142855e-04*G0_;
    block[143] = 1.116071428571425e-04*G0_;
    block[144] = 0.000000000000000e+00;
    block[145] = -1.004464285714284e-03*G0_;
    block[146] = -2.008928571428569e-03*G0_;
    block[147] = 4.017857142857135e-03*G0_;
    block[148] = 2.008928571428568e-03*G0_;
    block[149] = -1.004464285714285e-03*G0_;
    block[150] = 2.008928571428567e-03*G0_;
    block[151] = -1.004464285714283e-03*G0_;
    block[152] = 0.000000000000000e+00;
    block[153] = 0.000000000000000e+00;
    block[154] = -1.004464285714284e-03*G0_;
    block[155] = 0.000000000000000e+00;
    block[156] = -2.008928571428571e-03*G0_;
    block[157] = 0.000000000000000e+00;
    block[158] = 0.000000000000000e+00;
    block[159] = 0.000000000000000e+00;
    block[160] = -4.464285714285713e-04*G0_;
    block[161] = 2.232142857142856e-04*G0_;
    block[162] = 1.116071428571422e-04*G0_;
    block[163] = 1.116071428571423e-04*G0_;
    block[164] = -1.004464285714285e-03*G0_;
    block[165] = 0.000000000000000e+00;
    block[166] = -1.004464285714284e-03*G0_;
    block[167] = 2.008928571428568e-03*G0_;
    block[168] = 4.017857142857136e-03*G0_;
    block[169] = -2.008928571428568e-03*G0_;
    block[170] = 2.008928571428569e-03*G0_;
    block[171] = -1.004464285714283e-03*G0_;
    block[172] = -1.004464285714284e-03*G0_;
    block[173] = 0.000000000000000e+00;
    block[174] = 0.000000000000000e+00;
    block[175] = 0.000000000000000e+00;
    block[176] = -2.008928571428573e-03*G0_;
    block[177] = 0.000000000000000e+00;
    block[178] = 0.000000000000000e+00;
    block[179] = 0.000000000000000e+00;
    block[180] = 2.232142857142858e-04*G0_;
    block[181] = -4.464285714285716e-04*G0_;
    block[182] = 1.116071428571425e-04*G0_;
    block[183] = 1.116071428571429e-04*G0_;
    block[184] = 2.008928571428569e-03*G0_;
    block[185] = -1.004464285714284e-03*G0_;
    block[186] = 0.000000000000000e+00;
    block[187] = -1.004464285714285e-03*G0_;
    block[188] = -2.008928571428568e-03*G0_;
    block[189] = 4.017857142857136e-03*G0_;
    block[190] = -1.004464285714284e-03*G0_;
    block[191] = 0.000000000000000e+00;
    block[192] = 2.008928571428568e-03*G0_;
    block[193] = -1.004464285714284e-03*G0_;
    block[194] = 0.000000000000000e+00;
    block[195] = 0.000000000000000e+00;
    block[196] = 0.000000000000000e+00;
    block[197] = -2.008928571428569e-03*G0_;
    block[198] = 0.000000000000000e+00;
    block[199] = 0.000000000000000e+00;
    block[200] = -4.464285714285711e-04*G0_;
    block[201] = 1.116071428571425e-04*G0_;
    block[202] = 1.116071428571426e-04*G0_;
    block[203] = 2.232142857142850e-04*G0_;
    block[204] = 0.000000000000000e+00;
    block[205] = 0.000000000000000e+00;
    block[206] = -1.004464285714284e-03*G0_;
    block[207] = 2.008928571428567e-03*G0_;
    block[208] = 2.008928571428569e-03*G0_;
    block[209] = -1.004464285714284e-03*G0_;
    block[210] = 4.017857142857137e-03*G0_;
    block[211] = -2.008928571428569e-03*G0_;
    block[212] = 0.000000000000000e+00;
    block[213] = -1.004464285714286e-03*G0_;
    block[214] = 0.000000000000000e+00;
    block[215] = -1.004464285714285e-03*G0_;
    block[216] = -2.008928571428570e-03*G0_;
    block[217] = 0.000000000000000e+00;
    block[218] = 0.000000000000000e+00;
    block[219] = 0.000000000000000e+00;
    block[220] = 2.232142857142859e-04*G0_;
    block[221] = 1.116071428571428e-04*G0_;
    block[222] = 1.116071428571427e-04*G0_;
    block[223] = -4.464285714285702e-04*G0_;
    block[224] = 0.000000000000000e+00;
    block[225] = 0.000000000000000e+00;
    block[226] = 0.000000000000000e+00;
    block[227] = -1.004464285714283e-03*G0_;
    block[228] = -1.004464285714283e-03*G0_;
    block[229] = 0.000000000000000e+00;
    block[230] = -2.008928571428569e-03*G0_;
    block[231] = 4.017857142857138e-03*G0_;
    block[232] = -1.004464285714285e-03*G0_;
    block[233] = 2.008928571428569e-03*G0_;
    block[234] = -1.004464285714284e-03*G0_;
    block[235] = 2.008928571428569e-03*G0_;
    block[236] = 0.000000000000000e+00;
    block[237] = 0.000000000000000e+00;
    block[238] = 0.000000000000000e+00;
    block[239] = -2.008928571428570e-03*G0_;
    block[240] = 1.116071428571427e-04*G0_;
    block[241] = -4.464285714285719e-04*G0_;
    block[242] = 1.116071428571421e-04*G0_;
    block[243] = 2.232142857142851e-04*G0_;
    block[244] = 2.008928571428565e-03*G0_;
    block[245] = -1.004464285714282e-03*G0_;
    block[246] = 0.000000000000000e+00;
    block[247] = 0.000000000000000e+00;
    block[248] = -1.004464285714284e-03*G0_;
    block[249] = 2.008928571428568e-03*G0_;
    block[250] = 0.000000000000000e+00;
    block[251] = -1.004464285714285e-03*G0_;
    block[252] = 4.017857142857132e-03*G0_;
    block[253] = -2.008928571428568e-03*G0_;
    block[254] = 0.000000000000000e+00;
    block[255] = -1.004464285714285e-03*G0_;
    block[256] = 0.000000000000000e+00;
    block[257] = -2.008928571428570e-03*G0_;
    block[258] = 0.000000000000000e+00;
    block[259] = 0.000000000000000e+00;
    block[260] = 1.116071428571431e-04*G0_;
    block[261] = 2.232142857142861e-04*G0_;
    block[262] = 1.116071428571431e-04*G0_;
    block[263] = -4.464285714285703e-04*G0_;
    block[264] = -1.004464285714282e-03*G0_;
    block[265] = 0.000000000000000e+00;
    block[266] = 0.000000000000000e+00;
    block[267] = 0.000000000000000e+00;
    block[268] = 0.000000000000000e+00;
    block[269] = -1.004464285714284e-03*G0_;
    block[270] = -1.004464285714286e-03*G0_;
    block[271] = 2.008928571428569e-03*G0_;
    block[272] = -2.008928571428567e-03*G0_;
    block[273] = 4.017857142857138e-03*G0_;
    block[274] = -1.004464285714285e-03*G0_;
    block[275] = 2.008928571428569e-03*G0_;
    block[276] = 0.000000000000000e+00;
    block[277] = 0.000000000000000e+00;
    block[278] = 0.000000000000000e+00;
    block[279] = -2.008928571428569e-03*G0_;
    block[280] = 1.116071428571428e-04*G0_;
    block[281] = 1.116071428571432e-04*G0_;
    block[282] = -4.464285714285708e-04*G0_;
    block[283] = 2.232142857142855e-04*G0_;
    block[284] = -1.004464285714285e-03*G0_;
    block[285] = 2.008928571428570e-03*G0_;
    block[286] = 2.008928571428569e-03*G0_;
    block[287] = -1.004464285714284e-03*G0_;
    block[288] = 0.000000000000000e+00;
    block[289] = 0.000000000000000e+00;
    block[290] = 0.000000000000000e+00;
    block[291] = -1.004464285714284e-03*G0_;
    block[292] = 0.000000000000000e+00;
    block[293] = -1.004464285714285e-03*G0_;
    block[294] = 4.017857142857138e-03*G0_;
    block[295] = -2.008928571428569e-03*G0_;
    block[296] = 0.000000000000000e+00;
    block[297] = 0.000000000000000e+00;
    block[298] = -2.008928571428565e-03*G0_;
    block[299] = 0.000000000000000e+00;
    block[300] = 1.116071428571432e-04*G0_;
    block[301] = 1.116071428571429e-04*G0_;
    block[302] = 2.232142857142857e-04*G0_;
    block[303] = -4.464285714285702e-04*G0_;
    block[304] = 0.000000000000000e+00;
    block[305] = -1.004464285714285e-03*G0_;
    block[306] = -1.004464285714284e-03*G0_;
    block[307] = 0.000000000000000e+00;
    block[308] = 0.000000000000000e+00;
    block[309] = 0.000000000000000e+00;
    block[310] = -1.004464285714285e-03*G0_;
    block[311] = 2.008928571428569e-03*G0_;
    block[312] = -1.004464285714285e-03*G0_;
    block[313] = 2.008928571428569e-03*G0_;
    block[314] = -2.008928571428569e-03*G0_;
    block[315] = 4.017857142857140e-03*G0_;
    block[316] = 0.000000000000000e+00;
    block[317] = 0.000000000000000e+00;
    block[318] = 0.000000000000000e+00;
    block[319] = -2.008928571428568e-03*G0_;
    block[320] = 1.339285714285713e-03*G0_;
    block[321] = 6.696428571428579e-04*G0_;
    block[322] = 6.696428571428568e-04*G0_;
    block[323] = 6.696428571428557e-04*G0_;
    block[324] = 0.000000000000000e+00;
    block[325] = 0.000000000000000e+00;
    block[326] = 0.000000000000000e+00;
    block[327] = -2.008928571428571e-03*G0_;
    block[328] = -2.008928571428573e-03*G0_;
    block[329] = 0.000000000000000e+00;
    block[330] = -2.008928571428570e-03*G0_;
    block[331] = 0.000000000000000e+00;
    block[332] = 0.000000000000000e+00;
    block[333] = 0.000000000000000e+00;
    block[334] = 0.000000000000000e+00;
    block[335] = 0.000000000000000e+00;
    block[336] = 1.607142857142856e-02*G0_;
    block[337] = 8.035714285714287e-03*G0_;
    block[338] = 8.035714285714283e-03*G0_;
    block[339] = 8.035714285714280e-03*G0_;
    block[340] = 6.696428571428562e-04*G0_;
    block[341] = 1.339285714285713e-03*G0_;
    block[342] = 6.696428571428570e-04*G0_;
    block[343] = 6.696428571428560e-04*G0_;
    block[344] = -2.008928571428568e-03*G0_;
    block[345] = 0.000000000000000e+00;
    block[346] = 0.000000000000000e+00;
    block[347] = 0.000000000000000e+00;
    block[348] = 0.000000000000000e+00;
    block[349] = -2.008928571428568e-03*G0_;
    block[350] = 0.000000000000000e+00;
    block[351] = 0.000000000000000e+00;
    block[352] = -2.008928571428570e-03*G0_;
    block[353] = 0.000000000000000e+00;
    block[354] = 0.000000000000000e+00;
    block[355] = 0.000000000000000e+00;
    block[356] = 8.035714285714285e-03*G0_;
    block[357] = 1.607142857142857e-02*G0_;
    block[358] = 8.035714285714287e-03*G0_;
    block[359] = 8.035714285714275e-03*G0_;
    block[360] = 6.696428571428571e-04*G0_;
    block[361] = 6.696428571428576e-04*G0_;
    block[362] = 1.339285714285713e-03*G0_;
    block[363] = 6.696428571428564e-04*G0_;
    block[364] = 0.000000000000000e+00;
    block[365] = -2.008928571428569e-03*G0_;
    block[366] = -2.008928571428570e-03*G0_;
    block[367] = 0.000000000000000e+00;
    block[368] = 0.000000000000000e+00;
    block[369] = 0.000000000000000e+00;
    block[370] = 0.000000000000000e+00;
    block[371] = 0.000000000000000e+00;
    block[372] = 0.000000000000000e+00;
    block[373] = 0.000000000000000e+00;
    block[374] = -2.008928571428565e-03*G0_;
    block[375] = 0.000000000000000e+00;
    block[376] = 8.035714285714283e-03*G0_;
    block[377] = 8.035714285714287e-03*G0_;
    block[378] = 1.607142857142855e-02*G0_;
    block[379] = 8.035714285714280e-03*G0_;
    block[380] = 6.696428571428561e-04*G0_;
    block[381] = 6.696428571428564e-04*G0_;
    block[382] = 6.696428571428575e-04*G0_;
    block[383] = 1.339285714285711e-03*G0_;
    block[384] = 0.000000000000000e+00;
    block[385] = 0.000000000000000e+00;
    block[386] = 0.000000000000000e+00;
    block[387] = 0.000000000000000e+00;
    block[388] = 0.000000000000000e+00;
    block[389] = 0.000000000000000e+00;
    block[390] = 0.000000000000000e+00;
    block[391] = -2.008928571428570e-03*G0_;
    block[392] = 0.000000000000000e+00;
    block[393] = -2.008928571428569e-03*G0_;
    block[394] = 0.000000000000000e+00;
    block[395] = -2.008928571428568e-03*G0_;
    block[396] = 8.035714285714280e-03*G0_;
    block[397] = 8.035714285714275e-03*G0_;
    block[398] = 8.035714285714280e-03*G0_;
    block[399] = 1.607142857142855e-02*G0_;
  }

};

} }

#endif
